diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index c0060d244..67cf599d0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -93,7 +93,14 @@ public class FontRendererDefault extends FontRenderer {
                     if (formatCode != -1) {
                         switch (cNext) {
                             case '0': case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9': case 'a': case 'b': case 'c': case 'd': case 'e': case 'f': {
-                                this.currentConfig = SF.setColor(this.currentConfig, Colors.allChatColors[MathHelper.clamp(formatCode, 0, 15)].value);
+                                // Preserve the base alpha (e.g. chat fadeout) when
+                                // applying legacy text formatting colors.
+                                int rgb = Colors.allChatColors[MathHelper.clamp(formatCode, 0, 15)].value & 0x00_FF_FF_FF;
+                                int alpha = SF.getColor(baseConfig) & 0xFF_00_00_00;
+                                if (alpha == 0) {
+                                    alpha = 0xFF_00_00_00;
+                                }
+                                this.currentConfig = SF.setColor(this.currentConfig, rgb | alpha);
                                 break;
                             }
                             case 'k': {
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 2e6d097dc..11aca3cf6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -104,5 +104,5 @@ public abstract class ItemModel {
         GLRenderer.popFrame();
     }
 
-    public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
+    public abstract IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 1410f7417..ef0b3afca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -31,7 +31,7 @@ public class ItemModelBlock extends ItemModelStandard {
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack) {
         IconCoordinate overlay = this.blockModel.getOverlayTexture(itemStack.getMetadata());
         return overlay != null ? overlay : BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index 91db639ab..c9d62eed1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -14,8 +14,8 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.Math;
 
 public class ItemModelBow extends ItemModelStandard {
-    public ItemModelBow(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelBow(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
index a0a6d2f40..6bd95d81a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
@@ -18,11 +18,11 @@ public abstract class ItemModelBucket extends ItemModelStandard {
 
     protected final Map<NamespaceID, IconCoordinate[]> bucketIcons = new HashMap<>();
 
-    public ItemModelBucket(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelBucket(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
-    protected void initializeIcons(String namespace, String prefix, int maxCharges, Set<NamespaceID> validStates) {
+    protected void initializeIcons(@NotNull String namespace, @NotNull String prefix, int maxCharges, @NotNull Set<@NotNull NamespaceID> validStates) {
         IconCoordinate[] emptyArray = new IconCoordinate[1];
         emptyArray[0] = TextureRegistry.getTexture(namespace + ":item/" + prefix + "/empty");
         this.bucketIcons.put(ItemBucket.STATE_EMPTY, emptyArray);
@@ -42,7 +42,7 @@ public abstract class ItemModelBucket extends ItemModelStandard {
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack) {
         NamespaceID state = ItemBucket.getState(itemStack);
         int charges = ItemBucket.getCharges(itemStack);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java
index fc70c6e39..f7ee8c842 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java
@@ -3,12 +3,13 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Set;
 
 public class ItemModelBucketIron extends ItemModelBucket {
-    public ItemModelBucketIron(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelBucketIron(@NotNull Item item, String namespace) {
+        super(item, false);
         Set<NamespaceID> validStates = ItemBucket.getRegisteredStateIds();
         this.initializeIcons(namespace, "bucket_iron", 1, validStates);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java
index 13600c632..af71b6555 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java
@@ -3,12 +3,13 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Set;
 
 public class ItemModelBucketSteel extends ItemModelBucket {
-    public ItemModelBucketSteel(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelBucketSteel(@NotNull Item item, String namespace) {
+        super(item, false);
         Set<NamespaceID> validStates = ItemBucket.getRegisteredStateIds();
         this.initializeIcons(namespace, "bucket_steel", 3, validStates);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
index 2867671ad..2ba9ca2f6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
@@ -10,12 +10,12 @@ import org.jetbrains.annotations.Nullable;
 
 public class ItemModelCoal extends ItemModelStandard {
     protected IconCoordinate charcoal = TextureRegistry.getTexture("minecraft:item/charcoal");
-    public ItemModelCoal(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelCoal(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack)
     {
         if(itemStack.getMetadata() == 1)
             return charcoal;
